package org.commonjava.tensor.data.store;

import java.util.Set;

import org.apache.maven.graph.effective.EProjectGraph;
import org.apache.maven.graph.effective.EProjectNet;
import org.apache.maven.graph.effective.EProjectRelationships;
import org.apache.maven.graph.effective.ref.EProjectKey;
import org.commonjava.tensor.data.TensorDataException;

public interface TensorDataStore
{
    public static final String PROJECT_RELATIONSHIPS_CACHE = "tensor-effective-project-relationships";

    public static final String GRAPH_CACHE = "tensor-project-graphs";

    EProjectRelationships storeRelationshipSet( EProjectRelationships relationships, boolean force )
        throws TensorDataException;

    EProjectNet storeGraph( EProjectGraph graph, boolean force )
        throws TensorDataException;

    boolean containsRelationshipSet( EProjectKey key );

    boolean containsGraph( EProjectKey key );

    EProjectGraph getGraph( EProjectKey eProjectKey )
        throws TensorDataException;

    EProjectRelationships getRelationshipSet( EProjectKey eProjectKey )
        throws TensorDataException;

    Set<EProjectGraph> getAllGraphs()
        throws TensorDataException;

    Set<EProjectRelationships> getAllRelationshipSets()
        throws TensorDataException;

    Set<EProjectKey> getGraphKeys()
        throws TensorDataException;

    Set<EProjectKey> getRelationshipSetKeys()
        throws TensorDataException;

}
