package org.commonjava.tensor.inject;

import javax.enterprise.inject.Produces;

import org.commonjava.tensor.io.json.TensorSerializationAdapter;
import org.commonjava.web.json.ser.JsonSerializer;

@javax.enterprise.context.ApplicationScoped
public class TensorSerializerProvider
{

    private JsonSerializer serializer;

    @Produces
    @TensorData
    public synchronized JsonSerializer getTensorSerializer()
    {
        if ( serializer == null )
        {
            serializer = new JsonSerializer( new TensorSerializationAdapter() );
        }

        return serializer;
    }

}
